/*******************************************************************************
*  skSHT3x.c - xZT(SHT3x-DIS)p֐Cu                         *
*              (SHT30/SHT31/SHT35 )                                        *
*                                                                              *
*    SHT3x_Init        - foCX̏s                            *
*    SHT3x_CMDsend     - foCXփR}h𑗐M鏈                      *
*    SHT3x_SoftRST     - foCXփ\tgZbg𑗐M鏈                *
*    SHT3x_Heater      - foCX̃q[^[N/~鏈               *
*    SHT3x_StatusRead  - foCX̏ǂݍޏ                          *
*    SHT3x_MeasureRead - foCX̑f[^ǂݍݕʒl֊Z鏈  *
*    SHT3x_ContiStart  - foCX֘AJn𑗐M鏈                  *
*    SHT3x_ContiStop   - foCX֘A蒆~𑗐M鏈                  *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2020-01-23  ޒH[(ނ)  Create                          *
* ============================================================================ *
*  MPLAB X(v5.30)                                                              *
*  MPLAB(R) XC8 C Compiler Version 2.00                                        *
*******************************************************************************/
#include <xc.h>
#include "skSHT3x.h"
#include "skI2Clib.h"

static int Sensor_adrs ;      // foCXI2CAhXۑϐ

/*******************************************************************************
*  ans = SHT3x_CMDsend(*command)                                               *
*  foCXփR}h𑗐M鏈                                            *
*    *command    : MR}h̊i[w肷(2byte)             *
*    ans         : 0=  1=ُ(肩ACKԂĂȂ)                   *
*                         -1=̃}X^[Ƃ̃oXՓ˔                      *
*******************************************************************************/
int SHT3x_CMDsend(unsigned char *command)
{
     int ans ;

     ans = I2C_Start(Sensor_adrs,RW_0); // X^[gRfBV𔭍s
     if (ans == 0) {
          I2C_Send(*command) ;          // R}hMSB𑗐M
          command++ ;
          I2C_Send(*command) ;          // R}hLSB𑗐M
     }
     I2C_Stop() ;                       // XgbvRfBV𔭍s

     return ans ;
}
/*******************************************************************************
*  ans = SHT3x_SoftRST()                                                       *
*  foCXփ\tgZbg𑗐M鏈                                      *
*    ans   : 0=  1=ُ(肩ACKԂĂȂ)                         *
*                   -1=̃}X^[Ƃ̃oXՓ˔                            *
*******************************************************************************/
int SHT3x_SoftRST()
{
     int ans ;
     unsigned char data[2] ;

     data[0] = 0x30 ;                   // \tgZbgR}hMSB
     data[1] = 0xA2 ;                   // \tgZbgR}hLSB
     ans = SHT3x_CMDsend(data) ;
     __delay_ms(10) ;
     return ans ;
}
/*******************************************************************************
*  ans = SHT3x_Heater(onoff)                                                   *
*  foCX̃q[^[N/~鏈                                     *
*    onoff : 1=N(SHT3X_HEATER_ON)  0=~(SHT3X_HEATER_OFF)                 *
*    ans   : 0=  1=ُ(肩ACKԂĂȂ)                         *
*                   -1=̃}X^[Ƃ̃oXՓ˔                            *
*******************************************************************************/
int SHT3x_Heater(char onoff)
{
     unsigned char data[2] ;

     data[0] = 0x30 ;                                  // q[^[R}hMSB
     if (onoff == SHT3X_HEATER_ON) data[1] = 0x6D ;    // q[^[R}h(N)LSB
     else                          data[1] = 0x66 ;    // q[^[R}h(~)LSB
     return SHT3x_CMDsend(data) ;
}
/*******************************************************************************
*  ans = SHT3x_StatusRead(*sts)                                                *
*  foCX̏ǂݍޏ                                                *
*  q[^[̓ԁAA[gɊւԁAOɎMR}h          *
*  sԋyђOɎM݃f[^̃`FbNTƍʂ̏ԂB  *
*    *sts  : foCX̏i[w肷                                    *
*    ans   : 0=  1=ُ(肩ACKԂĂȂ)                         *
*                   -1=̃}X^[Ƃ̃oXՓ˔                            *
*******************************************************************************/
int SHT3x_StatusRead(unsigned int *sts)
{
     int ans ;
     unsigned int data[3] ;

     ans = I2C_Start(Sensor_adrs,RW_0);           // X^[gRfBV𔭍s
     if (ans == 0) {
          I2C_Send(0xF3) ;                        // Xe[^XR}hMSB𑗐M
          I2C_Send(0x2D) ;                        // Xe[^XR}hLSB𑗐M
          ans = I2C_rStart(Sensor_adrs,RW_1) ;    // s[gEX^[gRfBV𔭍s
          if (ans == 0) {
               data[0] = I2C_Receive(ACK) ;       // HIGHoCgǏo
               data[1] = I2C_Receive(ACK) ;       // LOWoCgǏo
               data[2] = I2C_Receive(NOACK) ;     // CRCoCgǏo(`FbN)
          }
          *sts = (data[0] << 8) | data[1] ;
     }
     I2C_Stop() ;                                 // XgbvRfBV𔭍s

     return ans ;
}
/*******************************************************************************
*  ans = SHT3x_MeasureRead(mode)                                               *
*  foCX̑f[^ǂݍݕʒl֊Z鏈                        *
*  xlTemperatureAxHumidityϐɑXϊĊi[܂B         *
*    mode  : 0=P  1=A                                            *
*    ans   : 0=  1=ُ(肩ACKԂĂȂ)                         *
*                   -1=̃}X^[Ƃ̃oXՓ˔                            *
*******************************************************************************/
int SHT3x_MeasureRead(int mode)
{
     int ans ;
     unsigned int data[6] ;

     ans = I2C_Start(Sensor_adrs,RW_0);           // X^[gRfBV𔭍s
     if (ans == 0) {
          if (mode == SHT3X_ONCE_MODE) {
               // PR}h(NbNXgb`)𔭍s
               I2C_Send(0x24) ;                   // MSB𑗐M
               I2C_Send(0x00) ;                   // LSB𑗐M
              __delay_ms(20) ;                    // I܂ő҂
          } else {
               // IAR}h𔭍s
               I2C_Send(0xE0) ;                   // MSB𑗐M
               I2C_Send(0x00) ;                   // LSB𑗐M
          }
          // l̓ǂݍ
          ans = I2C_rStart(Sensor_adrs,RW_1) ;    // s[gEX^[gRfBV𔭍s
          if (ans == 0) {
               // xǂݍ
               data[0] = I2C_Receive(ACK) ;       // HIGHoCgǏo
               data[1] = I2C_Receive(ACK) ;       // LOWoCgǏo
               data[2] = I2C_Receive(ACK) ;       // CRCoCgǏo(`FbN)
               // xǂݍ
               data[3] = I2C_Receive(ACK) ;       // HIGHoCgǏo
               data[4] = I2C_Receive(ACK) ;       // LOWoCgǏo
               data[5] = I2C_Receive(NOACK) ;     // CRCoCgǏo(`FbN)
          }
     }
     I2C_Stop() ;                                 // XgbvRfBV𔭍s
     // f[^𕨗ʒl֊Z
     if (ans == 0) {
          data[2] = (data[0] << 8) | data[1] ;
          data[5] = (data[3] << 8) | data[4] ;
          Temperature = -45.0 + (175.0 * (float)data[2] / 65535.0) ;  // 
          Humidity = (100.0 * (float)data[5]) / 65535.0 ;             // %RH
     }

     return ans ;
}
/*******************************************************************************
*  ans = SHT3x_ContiStop()                                                     *
*  foCX֘A蒆~𑗐M鏈                                        *
*    ans   : 0=  1=ُ(肩ACKԂĂȂ)                         *
*                   -1=̃}X^[Ƃ̃oXՓ˔                            *
*******************************************************************************/
int SHT3x_ContiStop()
{
     int ans ;
     unsigned char data[2] ;

     data[0] = 0x30 ;                   // A蒆~R}hMSB
     data[1] = 0x93 ;                   // A蒆~R}hLSB
     ans = SHT3x_CMDsend(data) ;
     __delay_ms(15) ;                   // 芮҂

     return ans ;
}
/*******************************************************************************
*  ans = SHT3x_ContiStart(mps,accuracy)                                        *
*  foCX֘AJn𑗐M鏈                                        *
*    mps      : pxw肵܂(AR}hMSB)                    *
*    accuracy : JԂxxw肵܂(AR}hLSB)            *
*    ans      : 0=  1=ُ(肩ACKԂĂȂ)                      *
*                      -1=̃}X^[Ƃ̃oXՓ˔                         *
*******************************************************************************/
int SHT3x_ContiStart(unsigned char mps,unsigned char accuracy)
{
     unsigned char data[2] ;

     data[0] = mps ;                    // IAR}hMSB
     data[1] = accuracy ;               // IAR}hLSB
     return SHT3x_CMDsend(data) ;
}
/*******************************************************************************
*  ans = SHT3x_Init(address)                                                   *
*  foCX̏s                                                  *
*  foCXI2CAhXo^ƃ\tgZbgsB                           *
*    address : foCXI2CAhXw肷                                 *
*    ans     : 0=  1=ُ(肩ACKԂĂȂ)                       *
*                     -1=̃}X^[Ƃ̃oXՓ˔                          *
*******************************************************************************/
int SHT3x_Init(int address)
{
     unsigned int sts ;

     Sensor_adrs = address ;
     return SHT3x_SoftRST() ;
}
